#include <iostream>
#include <fstream>
#include <vector>
#include "String.h"

int main(int argc, const char * argv[]) {
	std::vector<String> strs;
	std::vector<String> testStrs;
	std::vector<String> diffStrs;

	std::ifstream in;
	char buffer[64];

	String::initString();

	// Read the word list
	in.open("words.txt");
	while(in.getline(buffer,63)) {
		String newStr(buffer);
		strs.push_back(newStr);
	}
	in.close();

	// Read the test words
	in.open("test.txt");
	while(in.getline(buffer,63)) {
		String newStr(buffer);
		testStrs.push_back(newStr);
	}
	in.close();

	// Find all the test words that do not appear on the word list
	for(auto otr = testStrs.begin();otr != testStrs.end();otr++) {
		String testStr(*otr);
		bool found = false;
		for(auto itr = strs.begin();!found && itr != strs.end();itr++)
			if(*itr == testStr)
				found = true;

		if(!found)
			diffStrs.push_back(testStr);
	}

	// Print the test words that did not appear on the word list
	for(auto itr = diffStrs.begin();itr != diffStrs.end();itr++)
		std::cout << *itr << std::endl;

	// Display memory usage statistics
	std::cout << "Using memory: " << String::memoryUsage() << std::endl;
	std::cout << "Max memory: " << String::maxMemoryUsage() << std::endl;
	std::cout << "Copies made: " << String::copyCount() << std::endl;
	std::cout << "Moves made: " << String::moveCount() << std::endl;
	
	return 0;
}

